import org.joone.engine.*;
import org.joone.net.*;
import com.cycling74.max.*;

public class XorNet extends MaxObject {

	NeuralNet nnet = null;
	
	String snet = "C:/Users/jhu/Documents/Development/workspace/XOR/XOR.snet";

	DirectSynapse memInp = null;
	DirectSynapse memOut = null;
	
	public float inlet_left = 0;
	public float inlet_right = 0;

	public XorNet() {

		declareInlets(new int[]{DataTypes.FLOAT, DataTypes.FLOAT});
		declareOutlets(new int[]{DataTypes.FLOAT});
		initNet();

	}
	
	private void initNet(){
		NeuralNetLoader netLoader = new NeuralNetLoader(snet);
		nnet = netLoader.getNeuralNet();

		Layer input = nnet.getInputLayer();
		input.removeAllInputs();
		memInp = new DirectSynapse();
		input.addInputSynapse(memInp);

		Layer output = nnet.getOutputLayer();
		output.removeAllOutputs();
		memOut = new DirectSynapse();
		output.addOutputSynapse(memOut);

		nnet.getMonitor().setLearning(false);

		nnet.start();
	}
	
	public void inlet(float f){
		int inlet_no = getInlet();
		if(inlet_no == 0) 
			inlet_left = f;
		else
			inlet_right = f;
	}
	
	public void bang(){
		Pattern iPattern = new Pattern(new double[] { inlet_left, inlet_right });
		memInp.fwdPut(iPattern);
		Pattern oPattern = memOut.fwdGet();
		outlet(0, oPattern.getArray()[0]);
	}

}
